﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UCPasswordCombinationGenerator
{
    public partial class TokenInputPanel : UserControl
    {
        public TokenInputPanel()
        {
            InitializeComponent();
        }

        //public List<TokenInput> inputs = new List<TokenInput>();
        
        private void TokenInputPanel_Load(object sender, EventArgs e)
        {
            this.MouseWheel += new MouseEventHandler(TokenInputPanel_MouseWheel);

            AddInputControl();
        }

        void TokenInputPanel_MouseWheel(object sender, MouseEventArgs e)
        {
            bool scroll = true;
            //throw new NotImplementedException();
            foreach (Control c in pnlInputs.Controls)
            {
                if (c.GetType() == typeof(TextBox))
                {
                    if (c.Focused)
                    {
                        // do not scroll
                        scroll = true;
                        break;
                    }
                }
            }

            if (scroll)
            {
                pnlInputs.Focus();
            }
        }

        private void btnAddTokenInput_Click(object sender, EventArgs e)
        {
            int h = 180;
            if (pnlInputs.Controls.Count > 0)
            {
                h = ((TokenInput)pnlInputs.Controls[0]).Height;
            }
            else
            {
                TokenInput t = new TokenInput();
                h = t.Height;
            }

            AddInputControl(pnlInputs.Controls.Count, h);   
        }

        public void ResetControl()
        {
            pnlInputs.Controls.Clear();
            //AddInputControl();
        }

        public void AddInputControl()
        {
            int count = pnlInputs.Controls.Count; 
            TokenInput ti = new TokenInput(count + 1);
            ti.Width = this.Width - 5;
            ti.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
            //inputs.Add(ti);
            ti.RemoveControlEvent += new TokenInput.RemoveControlHandler(ti_RemoveControlEvent);
            pnlInputs.Controls.Add(ti);
            lblInputCount.Text = string.Format("Input count: {0}", count.ToString());
            SetTopsForInputs();
            _inputCount = pnlInputs.Controls.Count;
            lblInputCount.Text = string.Format("Input count: {0}", _inputCount.ToString());
        }

        void ti_RemoveControlEvent(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            //MessageBox.Show("Hit it!" + sender.GetType().ToString());
            Console.WriteLine(((TokenInput)sender).txtValue.Text);
            pnlInputs.Controls.Remove((Control)sender);
            Console.WriteLine(pnlInputs.Controls.Count.ToString()); 
            lblInputCount.Text = string.Format("Input count: {0}",pnlInputs.Controls.Count.ToString());

            // now, order them back up to the top...
            SetTops2();
            //int counter = 0;
            //foreach (Control c in pnlInputs.Controls)
            //{
            //    c.Top = (counter * c.Height) + 5;
            //    counter++;
            //}
        }


        public void AddInputControl(int count, int height)
        {    
            TokenInput ti = new TokenInput(count + 1, height);
            ti.Width = this.Width - 5;
            ti.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
            //inputs.Add(ti);
            ti.RemoveControlEvent += new TokenInput.RemoveControlHandler(ti_RemoveControlEvent);
            pnlInputs.Controls.Add(ti);
            lblInputCount.Text = string.Format("Input count: {0}", count.ToString());
            SetTopsForInputs();
            _inputCount = pnlInputs.Controls.Count;
            lblInputCount.Text = string.Format("Input count: {0}", _inputCount.ToString());
        }

        public void AddInputControl(TokenInput ti, int count)
        {
            //if (ti.Count == 0) ti.Count++;

            
            ti.Count = count;
            ti.Width = this.Width - 5;
            ti.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
            ti.RemoveControlEvent += new TokenInput.RemoveControlHandler(ti_RemoveControlEvent);
            pnlInputs.Controls.Add(ti);
            lblInputCount.Text = string.Format("Input count: {0}", count.ToString());
            SetTopsForInputs();
            _inputCount = pnlInputs.Controls.Count;
            lblInputCount.Text = string.Format("Input count: {0}", _inputCount.ToString());
        }

        public string[] GetInputLines(int index)
        {
            string[] result = new string[] {  };       
            result = ((TokenInput)pnlInputs.Controls[index]).txtValue.Lines;
            return result;
        }

        private int _inputCount = 0;

        public int InputCount
        {
            get { return _inputCount; }
            set { _inputCount = value; }
        }

        private int GetCurrentInputHeight()
        {
            int result;
            if (this.pnlInputs.Controls.Count > 0)
            {
                result = this.pnlInputs.Controls[0].Height;
            }
            else
            {
                result = new TokenInput().Height;              
            }
            return result; 
        }

        private void btnSmallerInput_Click(object sender, EventArgs e)
        {
            foreach (Control c in pnlInputs.Controls)
            {
                Console.WriteLine(c.ToString());
                if (c.GetType() == typeof(TokenInput))
                {
                    // we have the correct control
                    ((TokenInput)c).ReduceHeight(10);
                    ((TokenInput)c).Invalidate();
                    ((TokenInput)c).Refresh();    
                }
            }
            SetTopsForInputs();
        }

        private void SetTopsForInputs()
        {
            Point p = pnlInputs.AutoScrollPosition;
            pnlInputs.AutoScrollPosition = new Point(0, 0);

            int count = this.pnlInputs.Controls.Count;
            int height = 0;
            if (count > 0)
            {
                height = this.pnlInputs.Controls[0].Height;
            }

            foreach (Control c in pnlInputs.Controls)
            {
                ((TokenInput)c).Top = (((TokenInput)c).Count - 1) * (height + 3);
                ((TokenInput)c).Width = this.Width - 15;
            }

            try
            {
                Point np = new Point(0, -p.Y);
                pnlInputs.AutoScrollPosition = np;
            }
            catch
            {
            }
        }

        private void SetTops2()
        {
            Point p = pnlInputs.AutoScrollPosition;
            //pnlInputs.AutoScrollPosition = new Point(0, 0);
            pnlInputs.AutoScrollPosition = new Point(0, 0);
            int height = 0;
            if (pnlInputs.Controls.Count > 0)
            {
                height = pnlInputs.Controls[0].Height;
            }
            int counter = 0;
            foreach (Control c in pnlInputs.Controls)
            {
                c.Top = (counter * height) + 3;
                counter++;
                ((TokenInput)c).Count = (counter);
            }

            try
            {
                //Point np = new Point(0, -p.Y);
                //pnlInputs.AutoScrollPosition = np;
            }
            catch
            {
            }
        }

        private void btnTallerInput_Click(object sender, EventArgs e)
        {
            foreach (Control c in pnlInputs.Controls)
            {
                Console.WriteLine(c.ToString());
                if (c.GetType() == typeof(TokenInput))
                {
                    // we have the correct control
                    ((TokenInput)c).ReduceHeight(-10);
                    ((TokenInput)c).Invalidate();
                    ((TokenInput)c).Refresh();
                }
            }
            SetTopsForInputs();
        }

        public void RemoveBlankLinesFromAll()
        {
            foreach (TokenInput t in pnlInputs.Controls)
            {
                t.RemoveBlankLines();
            }
        }

        private void TokenInputPanel_SizeChanged(object sender, EventArgs e)
        {
            foreach (Control c in pnlInputs.Controls)
            {
                c.Width = this.Width - 5;
            }
            pnlInputs.AutoScroll = true;
        }

        private void lblInputCount_Click(object sender, EventArgs e)
        {
            this.pnlInputs.Focus();
        }
    }
}
